/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.kandidatur.boundary;

import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class DirektkandidaturDAO extends AbstractDirektkandidaturDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Direktkandidatur direktkandidatur){
    getEntityManager().persist(direktkandidatur);
  }

  public void remove(Direktkandidatur direktkandidatur){
    getEntityManager().remove(direktkandidatur);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                            
        /**
        * Name: WahlAndUngleichStatusNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Direktkandidatur o WHERE o.wahl=?1 AND o.kandidaturStatus!=?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Direktkandidatur> findByWahlAndUngleichStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.kandidatur.entity.KandidaturStatus kandidaturStatus) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidatur.findByWahlAndUngleichStatus" ,  wahl ,  kandidaturStatus  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlAndUngleichStatus( wahl ,  kandidaturStatus  ));
        }
        return (java.util.List<Direktkandidatur>) cached;
        }
            return super.findByWahlAndUngleichStatus( wahl ,  kandidaturStatus  );
            }
                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Direktkandidatur o WHERE o.wahl=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Direktkandidatur> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidatur.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Direktkandidatur>) cached;
        }
            return super.findByWahl( wahl  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}